package types

import (
	"git.nobla.cn/golang/kos/util/random"
	"github.com/google/uuid"
	"strings"
	"time"
)

type Tokenize struct {
	UID       string    `json:"uid"`
	Name      string    `json:"name"`
	Token     string    `json:"token"`
	ExpireIn  int       `json:"expire_in"`
	ExpiredAt time.Time `json:"-"`
}

func (tk *Tokenize) Validate() bool {
	return time.Now().Before(tk.ExpiredAt)
}

func NewTokenize(uid string, duration time.Duration) *Tokenize {
	return &Tokenize{
		UID:       uid,
		Token:     random.String(32) + strings.ReplaceAll(uuid.New().String(), "-", ""),
		ExpireIn:  int(duration / time.Second),
		ExpiredAt: time.Now().Add(duration),
	}
}
